#include "adaptormodel.h"
#include <QtCore/QMetaObject>
#include <QtCore/QString>
#include <QtCore/QVariant>

#include "vymmodel.h"

AdaptorModel::AdaptorModel(QObject *obj)
         : QDBusAbstractAdaptor(obj)
{
	model=static_cast <VymModel*> (obj);
	setAutoRelaySignals (true);
}

AdaptorModel::~AdaptorModel()
{
    // destructor
}

void AdaptorModel::setModel(VymModel *vm)
{
	model=vm;
}

QString AdaptorModel::caption()
{
	return m_caption;
}

void AdaptorModel::setCaption (const QString &newCaption)
{
	m_caption=newCaption;
}

QDBusVariant AdaptorModel::query(const QString &query)
{
	QString s;
	if (model)
		s=model->getHeading();
	else
		s="oops, no vymModel?";

	return QDBusVariant (s);
}

QDBusVariant AdaptorModel::getHeading()
{
	QString s;
	if (model)
		s=model->getHeading();
	else
		s="oops, no vymModel?";

	return QDBusVariant (s);
}


