#ifndef ADAPTORModel_H
#define ADAPTORModel_H

#include <QtCore/QObject>
#include <QtDBus/QtDBus>

class VymModel;
class QString;

class AdaptorModel: public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.insilmaril.Adaptor")
	Q_PROPERTY(QString caption READ caption WRITE setCaption)
private:
	VymModel *model;

public:
    AdaptorModel(QObject *obj);
    virtual ~AdaptorModel();
	void setModel (VymModel *vm);

public: // PROPERTIES
	QString m_caption;
	QString caption();
	void setCaption(const QString &newCaption);
public slots: // METHODS
   QDBusVariant query(const QString &query);
   QDBusVariant getHeading();

Q_SIGNALS: // SIGNALS
    void crashed();
};

#endif
