#include "treeeditor.h"

#include <QAction>
#include <QSortFilterProxyModel>
#include <QRegExp>

#include <iostream>
using namespace std;

#include "vymmodel.h"

#include "mysortfilterproxymodel.h"

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
TreeEditor::TreeEditor(VymModel *m)
{
	model=m;

/*
//	MySortFilterProxyModel *proxyModel = new MySortFilterProxyModel(this);	// FIXME-1 trying to use proxy...
	QSortFilterProxyModel *proxyModel = new QSortFilterProxyModel (this);

	proxyModel->setSourceModel(model);

	proxyModel->setFilterRegExp(QRegExp("x", Qt::CaseInsensitive));
	proxyModel->setFilterKeyColumn(0);
	proxyModel->setDynamicSortFilter (true);
//	setModel(proxyModel);
*/
	setModel(model);

	QAction *a;
	// Shortcuts for navigating with cursor:
    a = new QAction(tr( "Select upper object","Tree Editor" ), this);
	a->setStatusTip ( tr( "Select upper object" ));
	a->setShortcut (Qt::Key_Up );
	a->setShortcutContext (Qt::WidgetShortcut);
	addAction (a);
    connect( a, SIGNAL( triggered() ), this, SLOT( cursorUp() ) );

    a = new QAction( tr( "Select lower object","Tree Editor" ),this);
	a->setStatusTip (tr( "Select lower object" ));
	a->setShortcut ( Qt::Key_Down );
	a->setShortcutContext (Qt::WidgetShortcut);
	addAction (a);
    connect( a, SIGNAL( triggered() ), this, SLOT( cursorDown() ) );
}

TreeEditor::~TreeEditor()
{
	//cout <<"Destructor TreeEditor for "<<model->getMapName().toStdString()<<endl;
}

void TreeEditor::cursorUp()
{
	model->select (indexAbove (model->getSelectedIndex() ));
}

void TreeEditor::cursorDown()
{
	model->select (indexBelow (model->getSelectedIndex() ));
}

